module Metric where

-- Typeclass for points with a metric
class Eq pt => Metric pt where
	dist :: pt -> pt -> Double

-- Points in R^2
newtype R2 = R2 (Double, Double) deriving (Eq, Show)
-- Euclidean distance
instance Metric R2 where
	dist (R2 p1) (R2 p2) = sqrt ((fst p2 - fst p1)^2 + (snd p2 - snd p1)^2)
